//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Getdir.h"
#include <dir.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGAUGES"
#pragma link "NETOLib_OCX"
#pragma resource "*.dfm"
TForm1 *Form1;
long Baudrates[] = { 4800L, 9600L, 19200L, 38400L, 57600L, 115200L };
enumComType cmTypes[] = { comUpload, comDownload, comBoth };
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AddBtnClick(TObject *Sender)
{
    if( OpenDialog1->Execute() )
    {
        FilesList->Items->AddStrings( OpenDialog1->Files );
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RemoveBtnClick(TObject *Sender)
{
    int i;
    if( FilesList->SelCount <= 0 )
    {
        Application->MessageBox("No files selected", "ERROR INFO", MB_OK | MB_ICONERROR );
        return;
    }

    for( i = FilesList->Items->Count; i > 0 ; i-- )
    {
        if( FilesList->Selected[i-1] )
           FilesList->Items->Delete( i-1 );
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
    /* open the dialog for selecting a path */
    if( DirectoryFrm->ShowModal() == mrOk )
        Form1->PathName->Text = directory;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StartStopBtnClick(TObject *Sender)
{
    if(  StartStopBtn->Caption == "&Stop" )
    {
        NetoCtl1->StopRunning();
        return;
    }
    MsgLabel->Caption = "";
    Shape1->Brush->Color = clYellow;

    NetoCtl1->Comport = ComGroup->ItemIndex + 1;
    NetoCtl1->Baudrate = Baudrates[ BaudrateGroup->ItemIndex ];
    NetoCtl1->Parity = 0;   /* No Parity */
    NetoCtl1->ByteSize = 8; /* 8 databits per byte */
    NetoCtl1->StopBits = 0; /* 1 StopBit */
    NetoCtl1->PollSpeed = 250;  /* 250 ms per poll is 4 polls per second */
    NetoCtl1->PollTimeout = -1L; /* no timeout */
    NetoCtl1->IrDADevice = NoneIrda; /* No irda device connected to the COM port */
    NetoCtl1->RxTxDelay = 1;    /* 1 ms delay between sending receiving */

    VARIANT varFiles;
    BSTR*   bstrArray;
    WideString strbuf;

    VariantInit( &varFiles );
    varFiles.vt = VT_ARRAY | VT_BSTR;
    SAFEARRAYBOUND bounds[] = {FilesList->Items->Count, 0};
    SAFEARRAY* pArray = SafeArrayCreate( VT_BSTR, 1, bounds );

    SafeArrayAccessData( pArray, (void**) &bstrArray );
    for( int i = 0; i < FilesList->Items->Count; i++ )
    {
        strbuf = FilesList->Items->Strings[i];
        bstrArray[i] = SysAllocString( strbuf );
    }
    SafeArrayUnaccessData( pArray );
    varFiles.parray = pArray;

    strbuf = PathName->Text;
    int ret;
    if( (ret = NetoCtl1->UpDownload(L"&&&&&&", varFiles, strbuf, downOverWrite, cmTypes[ LoadGroup->ItemIndex ] )) < 0 )
    {
        AnsiString string;
        if( ret == -6 || ret == -7 )
            string = "Files not set";
        else if( ret == -3 )
            string = "Pathname is not set";
        else
            string = "undefined error";

        Application->MessageBox(string.c_str(), "Error", MB_OK | MB_ICONERROR );
        return;
    }
    StartStopBtn->Caption = "&Stop";
    Shape1->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    char buffer[ MAXPATH ];
    getcwd( buffer, MAXPATH );
    PathName->Text = (AnsiString) buffer;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::NetoCtl1ProtocolMessage(TObject *Sender,
      short msgCode, BSTR strMessage, short final, short Comport)
{
    WideString msgstr;
    msgstr = strMessage;
    MsgLabel->Caption = msgstr;
    if( final == 1 )
    {
        StartStopBtn->Caption = "&Start";
        Shape1->Visible = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::NetoCtl1Progress(TObject *Sender, short Current,
      short Total, short Comport)
{
    if( Total != 0 && Current != 0 )
        Shape1->Brush->Color = clLime;
    CurrGauge->Progress = Current;
    TotalGauge->Progress = Total;    
}
//---------------------------------------------------------------------------
